import { Compiler } from "webpack";
import { CachedSource } from "webpack-sources";
export declare class HtmlRendererWebpackPluginError extends Error {
    constructor(message: string);
}
export declare type RendererArgs = Partial<{
    assets: {
        [key: string]: string[] | undefined;
    };
    compilationAssets: {
        [key: string]: CachedSource;
    };
    filename: string;
    path: string;
    publicPath: string;
    stats: any;
}>;
export declare type Renderer = (args: RendererArgs) => string | Promise<string>;
export declare type Options = Partial<{
    hot: boolean;
    paths: string[];
    renderer: Renderer | string;
}>;
export default class HtmlRendererWebpackPlugin {
    private readonly paths;
    private readonly renderer;
    private src?;
    constructor({ paths, renderer }?: Options);
    private createRequireAsyncRenderer;
    private plugin;
    apply(compiler: Compiler): void;
}
