"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var webpack_sources_1 = require("webpack-sources");
var defaultRenderer_1 = __importDefault(require("./defaultRenderer"));
var filenameFromPath_1 = __importDefault(require("./filenameFromPath"));
var groupAssetsByExtensions_1 = __importDefault(require("./groupAssetsByExtensions"));
var PLUGIN_NAME = "HtmlRendererWebpackPlugin";
var chokidarOptions = {
    ignoreInitial: true,
    disableGlobbing: true,
    persistent: true
};
var HtmlRendererWebpackPluginError = /** @class */ (function (_super) {
    __extends(HtmlRendererWebpackPluginError, _super);
    function HtmlRendererWebpackPluginError(message) {
        return _super.call(this, "HtmlRendererWebpackPlugin Error:\n\n" + message) || this;
    }
    return HtmlRendererWebpackPluginError;
}(Error));
exports.HtmlRendererWebpackPluginError = HtmlRendererWebpackPluginError;
var HtmlRendererWebpackPlugin = /** @class */ (function () {
    function HtmlRendererWebpackPlugin(_a) {
        var _this = this;
        var _b = _a === void 0 ? {} : _a, _c = _b.paths, paths = _c === void 0 ? ["/"] : _c, _d = _b.renderer, renderer = _d === void 0 ? defaultRenderer_1.default : _d;
        this.createRequireAsyncRenderer = function (src) {
            var resolved = path_1.default.resolve(process.cwd(), src);
            _this.src = resolved;
            return function (args) { return __awaiter(_this, void 0, void 0, function () {
                var renderer;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require(resolved)); })];
                        case 1:
                            renderer = (_a.sent()).default;
                            return [2 /*return*/, renderer(args)];
                    }
                });
            }); };
        };
        this.plugin = function (compilation, done) { return __awaiter(_this, void 0, void 0, function () {
            var stats, publicPath, assets, _i, _a, path_2, filename, html, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        stats = compilation.getStats().toJson();
                        publicPath = (compilation.outputOptions || "").publicPath;
                        assets = groupAssetsByExtensions_1.default(compilation.assets);
                        _i = 0, _a = this.paths;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        path_2 = _a[_i];
                        filename = filenameFromPath_1.default(path_2);
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.renderer({
                                assets: assets,
                                compilationAssets: compilation.assets,
                                filename: filename,
                                path: path_2,
                                publicPath: publicPath,
                                stats: stats
                            })];
                    case 3:
                        html = _b.sent();
                        compilation.assets[filename] = new webpack_sources_1.RawSource(html);
                        return [3 /*break*/, 5];
                    case 4:
                        error_1 = _b.sent();
                        compilation.errors.push(new HtmlRendererWebpackPluginError(error_1.stack || error_1.message || error_1));
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6:
                        done();
                        return [2 /*return*/];
                }
            });
        }); };
        this.paths = paths;
        this.renderer =
            typeof renderer === "function"
                ? renderer
                : this.createRequireAsyncRenderer(renderer);
    }
    HtmlRendererWebpackPlugin.prototype.apply = function (compiler) {
        var _this = this;
        if (this.src) {
            compiler.hooks.afterCompile.tap(PLUGIN_NAME, function (compilation) {
                compilation.fileDependencies.add(_this.src);
            });
            var watcher_1;
            compiler.hooks.watchRun.tap(PLUGIN_NAME, function () { return __awaiter(_this, void 0, void 0, function () {
                var chokidar;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require("chokidar")); })];
                        case 1:
                            chokidar = _a.sent();
                            watcher_1 = chokidar.watch(this.src, chokidarOptions);
                            watcher_1.on("change", function () { }); // trigger compilation
                            return [2 /*return*/];
                    }
                });
            }); });
            compiler.hooks.watchClose.tap(PLUGIN_NAME, function () {
                if (watcher_1)
                    watcher_1.close();
            });
        }
        compiler.hooks.emit.tapAsync(PLUGIN_NAME, this.plugin);
    };
    return HtmlRendererWebpackPlugin;
}());
exports.default = HtmlRendererWebpackPlugin;
